// Vorlage:
// https://www.arduinoforum.de/arduino-Thread-SPIFFS-DOWNLOAD-UPLOAD-DELETE-Esp8266-NodeMCU?page=4
// ESP8266_Testseite_04.ino, Datum_Uhrzeit_01.htm

/*
    Achtung Dateinahmen mit mehr als 30 Zeichen werden beim Upload von links gekürzt
    urlDecode wurde hinzugefügt
    Funktioniert jetzt auch über DynDNS (z.B.: My Fritz)
*/
#include <ESP8266WebServer.h>
#include <ArduinoOTA.h>
#include <TimeLib.h>


const char* ssid = "jbaben";          //Zugangsdaten deines Routers einfügen
const char* password = "jbaben1955";
const String header = "HTTP/1.1 303 OK\r\nLocation:/\r\nCache-Control: no-cache\r\n\r\n";
const int LED_BLUE = D4;      // GPIO02 --> 2
const int GEYSER = D0;       // GPIO16 --> 16
const int LED_YELLOW = 10;   // GPIO10 -->  10 (S3)
const int LAMP_OUTSIDE = 9;    // GPIO9 --> 9 (S2)
const int GEYSER_IN = D5;      // GPIO4
const int LAMP_IN = D2;       // GPIO14

// Variable Timer
unsigned long millisekunden;
unsigned long aus;
int zuweisung = 0;

int Time;

void handleRoot();              // function prototypes for HTTP handlers
void handleNotFound();
void GeyserTime();
String temp = ""; 

// output status variables:
boolean ledblue_state = false;
boolean geyser_state = false;
boolean ledyellow_state = false;
boolean lampoutside_state = false;

ESP8266WebServer server(80);


void setup() {
  // preparing GPIOs
  pinMode(LED_BLUE, OUTPUT);
  pinMode(GEYSER, OUTPUT);
  pinMode(LED_YELLOW, OUTPUT);
  pinMode(LAMP_OUTSIDE, OUTPUT);
  pinMode(GEYSER_IN, INPUT);
  pinMode(LAMP_IN, INPUT);
  digitalWrite(LED_BLUE, HIGH);
  digitalWrite(GEYSER, LOW);
  digitalWrite(LED_YELLOW, LOW);
  digitalWrite(LAMP_OUTSIDE, LOW);
  delay(1000);

  Serial.begin(9600);
  WiFi.mode(WIFI_STA);         //Stationst-Modus --> Esp8266 im Heimnetzwerk einloggen
  //  WiFi.mode(WIFI_AP_STA);        //Stations- und Soft-Access-Point-Modus --> Access-Point Adresse http://192.168.4.1/
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay (500);
    Serial.print(".");
  }
  ArduinoOTA.begin();                       // https://arduino-esp8266.readthedocs.io/en/latest/ota_updates/readme.html
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
//  server.begin();
  // print start page:
  server.on("/", HTTP_POST, GeyserTime);
  server.on("/", handleRoot);

    // control output GEYSER:
    server.on("/geyserOn", [&]() {
    server.sendHeader("Location","/"); 
    server.send(303); 
    //server.send(200, "text/html", temp);
    digitalWrite(GEYSER, HIGH);
    if (zuweisung == 0) 
    { 
      aus = millis() + 5000;  // 30 minutes = 1800000 Millisekunden
      zuweisung = 1;
      Serial.println("Zuweisung");
      Serial.println(aus);
    }
    delay(500);
    geyser_state = digitalRead(GEYSER_IN);
    Serial.print("Status Geyser ");
    Serial.println(geyser_state);
    //server.send(303, "text/plain", "Status = High"); 
  });
  server.on("/geyserOff", [&](){
    server.sendHeader("Location","/"); 
    server.send(303);
    //server.send(200, "text/html", temp);
    digitalWrite(GEYSER, LOW);
    delay(500); 
    geyser_state = digitalRead(GEYSER_IN);
  }); 
 // control output LAMP Outside
  server.on("/lampoutsideOn", [&](){
    server.sendHeader("Location","/"); 
    server.send(303);
    //server.send(200, "text/html", temp);
    digitalWrite(LAMP_OUTSIDE, HIGH);
    delay(500);
    lampoutside_state = digitalRead(LAMP_OUTSIDE);
  });
  server.on("/lampoutsideOff", [&](){
    server.sendHeader("Location","/"); 
    server.send(303);
    //server.send(200, "text/html", temp);
    digitalWrite(LAMP_OUTSIDE, LOW);
    delay(500); 
    lampoutside_state = digitalRead(LAMP_OUTSIDE);
  });
  
  server.onNotFound(handleNotFound);
 
  server.begin();
  Serial.println("HTTP server started");
  
 
}

void loop() {
  ArduinoOTA.handle();
  server.handleClient();
  // Füge hier deinen Code ein:
  delay(1000);
  digitalWrite(LED_BLUE, HIGH);
  

}

void handleRoot() {                     // HTML Startseite
  // Variable Datum und Uhrzeit
  
  temp += "<!DOCTYPE HTML>\n<html lang='de'>\n<head><meta http-equiv='refresh' content='5'/><meta charset='UTF-8'><meta name= viewport content='width=device-width, initial-scale=1.0,'>";
  temp += "<style type='text/css'><!-- DIV.container { min-height: 10em; display: table-cell; vertical-align: middle }.button {height:35px; width:90px; font-size:16px} -->";
  temp += "body {background-color: powderblue;}</style>\n<script>function jn(text) {return confirm(text);}</script>";
  temp += "<script type='text/javascript'>function startTime() {var today = new Date();var year = today.getYear();if(year<1000) year+=1900;var h = today.getHours();var m = today.getMinutes();";
  temp += "var s = today.getSeconds();var day = today.getDate();var d = GetDay(today.getDay());var mo = GetMonth(today.getMonth());m = checkTime(m);s = checkTime(s);document.getElementById('uhr').innerHTML =";
  temp += "d + ' ' + day + ' ' + mo + ' ' + year + ' ' + h + ':' + m + ':' + s;var t = setTimeout(startTime, 500);}";
  temp += "function checkTime(i) {if (i < 10) {i = '0' + i}; return i;}";
  temp += "function GetDay(intDay){ var DayArray = new Array('Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag'); return DayArray[intDay];}";
  temp += "function GetMonth(intMonth){var MonthArray = new Array('Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember');return MonthArray[intMonth];}";
  temp += "</script>\n";
  temp += "</head>\n<body onload='startTime()'><left><h2>Ansteuerung Geyser/Außenbeleuchtung</h2></left><p>\n";
 
  // Tabellenspalte LED Ansteuerung
  temp += "<table><td><div align='left'><h3>Ansteuerung&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Status</h3</div><p>"; 
  
  temp += "<p>Geyser&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=\'/geyserOn\'><button>ON</button></a>&nbsp;<a href=\'/geyserOff\'><button>OFF</button></a>";
  // Status Geyser
  geyser_state = digitalRead(GEYSER);   // Eingang Schuetz
  if (geyser_state == 1)
  {
    temp += "&nbsp;&nbsp;&nbsp;<a href='output2'><button>ON</button></a>";
  }
  else
  {
    temp += "&nbsp;&nbsp;&nbsp;<a href='output2'><button>OFF</button></a>";
  }
  //temp += "&nbsp;&nbsp;&nbsp;<input type='text' name='Laufzeit' placeholder='Zeit hier einfügen' required>";
  temp += "&nbsp;&nbsp;&nbsp;<form action='/' method='POST'>";
  //temp += "<input type='submit' class='button' name='SUBMIT' value='Start'></p></form>";
  temp += "<input type='text' name='Time' placeholder='Zeit hier einfügen' required>\r\n<br>";
  //temp += "<p>START Geyser&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=\'/time\'><button>ON</button></a>";
  temp += "<input type='submit' class='button' name='SUBMIT' value='START'></form><p>";  
  
  // Ansteuerung Aussenbeleuchtung
  temp += "<p>Beleuchtung&nbsp;&nbsp;&nbsp;&nbsp; <a href=\'lampoutsideOn\'><button>ON</button></a>&nbsp;<a href=\'lampoutsideOff\'><button>OFF</button></a>";
  // Status Beleuchtung
  lampoutside_state = digitalRead(LAMP_OUTSIDE);  // Eingang Schuetz
  if (lampoutside_state == 1)
  {
    temp += "&nbsp;&nbsp;&nbsp;<a href='output4'><button>ON</button></a></p>";
  }
  else
  {
    temp += "&nbsp;&nbsp;&nbsp;<a href='output4'><button>OFF</button></a></p>";
  }
  temp += "</td></tr></table>";
  // Date and Time
  temp += "<br><div id ='uhr'></div>";
  temp += "</body></html>";
  server.send(200, "text/html", temp);
  temp = "";
  // Button Manuell Geyser ON/OFF
  if (digitalRead(GEYSER_IN) == HIGH && digitalRead(GEYSER) == LOW)
  {  
    digitalWrite(GEYSER, HIGH);
    geyser_state = 1;
    if (zuweisung == 0) 
  { 
    aus = millis() + 10000;    // 30 minutes = 1800000 Millisekunden
    zuweisung = 1;
  }
    delay(500);
  }
  if (digitalRead(GEYSER_IN) == HIGH && digitalRead(GEYSER) == HIGH)
  {  
    digitalWrite(GEYSER, LOW);
    geyser_state = 0;
    delay(500);
  }

  // Switch On Time Geyser = 30 minutes (30 minutes = 1800000 Millisekunden)
  if (aus <= millis())
  {
    digitalWrite(GEYSER, LOW);
    geyser_state = 0;
    zuweisung = 0;
  }

// Button Manuell Lamp ON/OFF
  if (digitalRead(LAMP_IN) == HIGH && digitalRead(LAMP_OUTSIDE) == LOW)
  {  
    digitalWrite(LAMP_OUTSIDE, HIGH);
    lampoutside_state = 1;
    delay(500);
  }
  if (digitalRead(LAMP_IN) == HIGH && digitalRead(LAMP_OUTSIDE) == HIGH)
  {  
    digitalWrite(LAMP_OUTSIDE, LOW);
    lampoutside_state = 0;
    delay(500);
  }

  
}

void handleNotFound(){
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET)?"GET":"POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i=0; i<server.args(); i++){
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
}

void GeyserTime() {                                     // Geyser Zeit starten 
  if (server.args() == 0) return handleRoot();
  if (server.hasArg("Time")) {
    Serial.println("Zeit Geyser starten");
    digitalWrite(LED_BLUE, LOW);
    String header = "HTTP/1.1 303 OK\r\nLocation:";
    header += server.uri();
    header += "\r\nCache-Control: no-cache\r\n\r\n";
    server.sendContent(header);
    return ;
  }
  
  // handleRoot();
}



